#
#===========================================================================
#=                                                                         =
#=  (C) Copyright 1995, Computer Technology Institute (CTI)                =
#=                                                                         =
#=  Permission to use, copy, modify and distribute this software and       =
#=  its documentation for non-commercial use and without fee is hereby     =
#=  granted, provided that the above copyright notice appear in all        =
#=  copies and that both that copyright notice and this permission         =
#=  notice and warranty disclaimer appear in supporting documentation,     =
#=  and that the name of Computer Technology Institute (CTI) or any of     =
#=  its entities not be used in advertising or publicity pertaining to     =
#=  distribution of the software and its documentation without specific    =
#=  prior permission.                                                      =
#=                                                                         =
#=  Computer Technology Institute (CTI) disclaims all warranties with      =
#=  regard to this software and makes no representations about the         =
#=  suitability of this software and its documentation for any purpose.    =
#=  It is provided "as is" without expressed or implied warranty.          =
#=                                                                         =
#===========================================================================
#=                                                                         =
#=                        Project CTI-Print                                =
#=                                                                         =
#= File:                                                                   =
#=   Make.inc                                                              =
#=                                                                         =
#= Synopsis:                                                               =
#=   This is the file included by Makefile where the variables are set.    =
#=                                                                         =
#= Author:                                                                 =
#=   Panos Dimakopoulos, Systems Programmer,                                =
#=   Computer Technology Institute,                                        =
#=   Division of Computing Facilities,                                     =
#=   P.O. Box 1122,                                                        =
#=   261 10  Patras,                                                       =
#=   Greece                                                                =
#=   (e-mail: dimakop@cti.gr)                                              =
#=   Tel: +30 61 992061                                                    =
#=   Fax: +30 61 993973                                                    =
#=                                                                         =
#===========================================================================
#


#============================================================================
#= Modification History:
#= 	Revision 1.1	95/01/12	18:22:58
#=		 Creation.
#= 	Revision 1.2	95/02/10	13:44:22
#=		 Full CTI address.
#= 	Revision 1.3	95/02/10	19:40:37
#=		 Subdirectory hp removed from default installation path.
#= 	Revision 1.4	95/02/14	12:24:54
#=		 Copyright notice changed.
#= 	Revision 1.5	95/07/28	17:45:30
#=		 Defines for Solaris added.
#= 	Revision %I%	%E%	%U%
#=		 CC path added.
#=
#

HOST=hermes.cti.gr

#**************** OPTIONS *******************************

DEFINES= -DSVR4	# For Solaris 2.x
LIBS= -lnsl		# For Solaris 2.x ; Do not use ucblib!!
CC= gcc 

# where the filters are installed:
INSTDIR=/var/spool/lpd/CTI-Print/filters
INSTDIR=/home/Alceste/stef/PLP/tmp/CTI-Print/filters
# where the fonts are installed (this path should agree
# with the one in FONTPATH).
FONTDIR=/var/spool/lpd/CTI-Print/fonts
FONTDIR=/home/Alceste/stef/PLP/tmp/CTI-Print/fonts

# Directory where the configuration files are to be placed
ETC=/usr/etc/plp
ETC=/home/Alceste/stef/PLP/tmp
# Directory where the manual pages are to be placed
MAN=/usr/man
# File with fonts to be downloaded varying with the requesting machine.
MACHINESFONTS= "-DMACHINESFONTS=\"/usr/etc/plp/host_fonts.\""
MACHINESFONTS= "-DMACHINESFONTS=\"/home/Alceste/stef/PLP/tmp/host_fonts.\""

# Path under which fonts are searched according to the info
# specified in MACHINESFONTS file.
FONTPATH= "-DFONTPATH=\"/var/spool/lpd/CTI-Print/fonts\""
FONTPATH= "-DFONTPATH=\"/home/Alceste/stef/PLP/tmp/CTI-Print/fonts\""
# Default font for the case that no entry exists for a 
# machine in previous file.
DEFLTFONT= "-DDEFLTFONT=\"elot-928/c1201c.10\""
DEFLTFONT= "-DDEFLTFONT=\"elot-928/c1201c.10\""
# Printer permissions file prefix.
ETCPERMS= "-DETCPERMS=\"/usr/etc/plp/printer_perms.\""
ETCPERMS= "-DETCPERMS=\"/home/Alceste/stef/PLP/tmp/printer_perms.\""
