#!/bin/sh
#
#===========================================================================
#=                                                                         =
#=  (C) Copyright 1995, Computer Technology Institute (CTI)                =
#=                                                                         =
#=  Permission to use, copy, modify and distribute this software and       =
#=  its documentation for non-commercial use and without fee is hereby     =
#=  granted, provided that the above copyright notice appear in all        =
#=  copies and that both that copyright notice and this permission         =
#=  notice and warranty disclaimer appear in supporting documentation,     =
#=  and that the name of Computer Technology Institute (CTI) or any of     =
#=  its entities not be used in advertising or publicity pertaining to     =
#=  distribution of the software and its documentation without specific    =
#=  prior permission.                                                      =
#=                                                                         =
#=  Computer Technology Institute (CTI) disclaims all warranties with      =
#=  regard to this software and makes no representations about the         =
#=  suitability of this software and its documentation for any purpose.    =
#=  It is provided "as is" without expressed or implied warranty.          =
#=                                                                         =
#===========================================================================
#=                                                                         =
#=                        Project CTI-Print                                =
#=                                                                         =
#= File:                                                                   =
#=   ifhpiii.sh                                                            =
#=                                                                         =
#= Synopsis:                                                               =
#=   This script sets the required env vars which affect the filter.       =
#=                                                                         =
#= Author:                                                                 =
#=   Panos Dimakopoulos, Systems Programmer,                               =
#=   Computer Technology Institute,                                        =
#=   Division of Computing Facilities,                                     =
#=   P.O. Box 1122,                                                        =
#=   261 10  Patras,                                                       =
#=   Greece                                                                =
#=   (e-mail: dimakop@cti.gr)                                              =
#=   Tel: +30 61 992061                                                    =
#=   Fax: +30 61 993973                                                    =
#=                                                                         =
#===========================================================================
#


#============================================================================
#= Modification History:
#= 	Revision 1.1	94/10/01	21:31:23
#=		 Creation.
#= 	Revision 1.2	94/12/08	12:49:18
#=		 MODEL env variable can be placed in thios script with values
#=		 III, IIID or IIISi.
#= 	Revision 1.3	95/02/10	18:24:29
#=		 Full CTI address.
#= 	Revision 1.4	95/02/14	13:30:44
#=		 New Copyright notice.
#= 	Revision 1.5	95/03/03	17:20:55
#=		 Filter is exec'ed with $@ now instead of $*.
#=
#


TRACE=OFF
export TRACE

MODEL=IIID
export MODEL

RETRIES=4
export RETRIES

SLEEPTIME=40
export SLEEPTIME

WRAP=ON
export WRAP

CARTRIDGE=OFF
export CARTRIDGE

exec /usr/lib/CTI-Print/filters/ifhpiii "$@"
