/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: cleanup.c,v 1.2 1995/09/04 14:57:49 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


void cleanup(sig)
int sig;
{
	int exitval = 0;


	log(4,"Signal %s received-entering cleanup", Sigstr(sig) );

	if( monitpid == 0 ){
		/* we are the child - race condition here before child sets handlers */
		exit(0);
	}
	switch (sig) {
		case SIGINT:		/* Sent by lpd to terminate job */
		case SIGCHLD:
		case SIGTERM:
		case SIGHUP:
		case SIGQUIT:
		case SIGPIPE:
			exitval = FILTRETRY;
			break;
		case SIGSEGV:
		case SIGBUS:
			signal(SIGCHLD,SIG_DFL);
				/* Otherwise father receives SIGCHLD as well
				 * when he kills the child.
				 */
			exitval = FILTRETRY;
			break;
		default:
			log(4,"Signal Ignored");
			break;
	}
	if( exitval ){
			log(3,"Job Interrupted");
			pr_endjob(STDOUT);
			write_check(STDOUT, USTPJLOFF, "Cannot send USTPJLOFF", 0);
			write_check(STDOUT, UELPJL, "Cannot send UELPJL", 0);
			fexit(exitval);
	}
}

