/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: get_num.c,v 1.1 1995/09/02 15:12:39 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


/*
 * The passed argument is supposed to be a string starting off with any
 * pattern (such as "PAGES=" or "CODE=") and followed by a number.
 * The number is returned as this is the one of major concern.
 */
int get_num(s)
char *s;
{
	int i = 0;

	if (!s) return(0);

	while ( *s && (!isdigit(*s)) )	s++ ;
	if ( *s )	i = atoi( s );

	return( i );
}

