/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/

#define EXTERN

/*
 * $Id: ifhp.c,v 1.4 1995/11/06 03:16:51 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"

static char idallf[] = "@(#) Computer Technology Institute, CTI-Print Project";
static char idhp4[] = "@(#)       Filter for HP LaserJet 4, V 1.2 \n" ;
static char idifhp4[] = "@(#) ifhp4.c 95/08/23 - V 1.15" ;

int main(argc,argv,envp)
int argc;
char *argv[];
char *envp[];
{
	Envp = envp;
	debug = 2;
	getargs( argc, argv );
	get_info();
	errorcode = FILTABORT;
	getpjlargs();

	(void)signal(SIGCHLD, nochildren);
	(void)signal(SIGINT, cleanup);
	(void)signal(SIGHUP, cleanup);
	(void)signal(SIGTERM, cleanup);
	(void)signal(SIGQUIT, cleanup);
	(void)signal(SIGPIPE, cleanup);

	/* open device if specified */
	if( device ) open_device();

	log(4,"ifhp: get_status %d", get_status );

	if( get_status && debug < 10 ){
		do_monitor();
	}
	if( !get_status ){
		header_info();
	}


	if( of_filter ){
		log(3,"ifhp: starting of_filter actions");
		do_of_stream(stdin, STDOUT );
	} else {
		log(3,"ifhp: starting if_filter actions");
		sendjob(stdin, STDOUT );
	}

	/* terminate job */

	if( get_status && debug < 10 ){
		check_job_end();
		if( pagecount ){
			npages = pr_pagecount(STDOUT);
		}
		log(2,"Initial page count %d, final %d, Total pages = %d",
		initialpagecount, npages, npages - initialpagecount );
		write_check(STDOUT, USTPJLOFF, "Cannot send USTPJLOFF", 0);
		write_check(STDOUT, UELPJL, "Cannot send UELPJL", 0);
		doaccnt(0);
	}
	if( !get_status ){
		header_info();
	}
	
	fexit(FILTSUCC);
	return( 0 );
}
