/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: readpipe.c,v 1.2 1995/09/04 14:58:12 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"

#define UNSOL(msg,X) (!strncmp(msg,X,strlen(X)))
char CODE[]  = "CODE=";
char PAGECOUNT[]  = "PAGECOUNT";


int readpipe(inptr, timeout)
int *inptr;
int timeout;
{
	int   n, cd;
	char *s;
	if( inptr ) *inptr = -1;

	if ( (n=port_readline(pipefd[0],readprin,sizeof(readprin)-1,timeout)) <0 ) {
		logerr(2,"Could not read from pipe");
		return( -1 );
	} else {
		log(3,"readpipe: '%s'", readprin);
		if ( n == 0 )	return n;
	}

	if( (s = getcrstr(readprin, CODE, sizeof(CODE)-1 )) ) {
		cd = get_num( s );
		if( inptr ){
			*inptr = cd;
		}
		check_code( cd );
	}
	if( (s = getcrstr(readprin, PAGECOUNT, sizeof(PAGECOUNT)-1)) ) {
		npages = get_num( s );
		log(2,"Pagecounter = %d", npages);
	}
	if( getcrstr( readprin, job_start, strlen( job_start )-2) ) {
		job_started	= TRUE;
		log(3,"readpipe: job started");
	} else if( getcrstr( readprin, job_end, strlen( job_end )-2) ) {
		log(3,"readpipe: job ended");
		job_ended	= TRUE;
	}
	return n;
}
