/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: sendfont.c,v 1.2 1995/09/10 14:43:31 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


int sendfont(fontfilename)
char *fontfilename;
{
	FILE *ffp;
	int n;

	log(4,"sendfont: sending '%s'", fontfilename );


	if ((ffp=fopen(fontfilename,"r")) == NULL) {
		logerr(1,"sendfont: cannot open file '%s'",fontfilename);
		return(1);
	}

	write_check(STDOUT, ASSIGN, "sendfont: cannot send ASSIGN font string", DIE);

	while ((n = getc(ffp)) != EOF){
		if (putc(n,stdout) != n){
			logerr_die(2,"sendfont: ASCII '%c' not written to printer",n);
		}
	}
	fclose(ffp);
	fflush(stdout);

	write_check(STDOUT, PGRESET, "Cannot send PGRESET font string", DIE);
	write_check(STDOUT, ASSIGN, "Cannot send ASSIGN string", DIE);
	write_check(STDOUT, MKPRIM, "Cannot send MKPRIM string", DIE);
	write_check(STDOUT, MKPERM, "Cannot send MKPERM string", DIE);

	log(4,"sendfont: done");
	return(0); /* success */
}

