/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: wake_up.c,v 1.1 1995/09/02 15:12:53 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"

static char Wakeup_str[]="\033(8U\033(s1p24v0s0b4148T\033*p100x900YWarming Up \
\033*p100x1100Ythe Printer";

void wake_up()
{
	int cou;
	int n;
	static int   woken=FALSE;


	log(2,"Warming Up Process");
	if ( woken==TRUE ) {
		log(4,"But printer already awake...");
		return;
	}
	woken = TRUE ;

	log(4,"wake_up: setting PCL Mode");
	write_check(STDOUT, PCLON, "Cannot set PCL Mode", DIE);
	log(4,"wake_up: sending NULLS");
	for ( cou=1000; cou > 0 ; cou-=n ){
		n = cou;
		if( n > sizeof(null_str) ) n = sizeof(null_str);
		if ( writecn(STDOUT,null_str,n) != n ){
			logerr_die(3,"Cannot send nulls");
		}
	}
	log(4,"wake_up: sending wakeup str '%s'", Wakeup_str);
	write_check(STDOUT, Wakeup_str, "Cannot send WAKEUP string", DIE);
	log(4,"wake_up: resetting printer '%s'", Wakeup_str);
	pclresetprinter();
	log(4,"wake_up: sending '%s'", UELPJL );
	write_check(STDOUT, UELPJL, "Cannot send UELPJL", DIE);
}
