proc dialhelp { topw text helpfile line} {
# This is a modified version of dialog.tcl from the distribution.
# It sets up a dialogbox with the contents from the help.txt
# file, including hypertext marking of keywords
 
 global tk_priv backgr4 language helpchapterlines
 # 1. Create the top-level window and divide it into top 
 # and bottom part
 
 catch {destroy .listb}
 toplevel $topw -class Dialog
 wm iconname $topw Dialog
 wm protocol $topw WM_DELETE_WINDOW { }
 wm transient $topw [winfo toplevel [winfo parent $topw]]
 frame $topw.top -relief raised -bd 1
 pack $topw.top -side top -fill both -expand 1
 frame $topw.mid -relief flat -bd 3
 pack $topw.mid -side top -fill both 
 frame $topw.bot -relief raised -bd 1
 pack $topw.bot -side bottom -fill both 
 
 # 2. Fill the top part with text and widget
 option add *Dialog.msg.wrapLength 3i widgetDefault
 label $topw.msg -text $text
 global fontdialog fonthelptext fontbighelptext path
 catch {$topw.msg configure -font $fontdialog }
 pack $topw.msg -in $topw.top -side top -expand 1 -fill both \
  -padx 3m -pady 1m
 text $topw.text -relief groove -bd 2 \
   -yscrollcommand "$topw.scroll set" -width 55 -height 20 \
   -wrap word -font $fonthelptext -bg $backgr4
 scrollbar $topw.scroll -command "$topw.text yview" -width 10
 pack $topw.text -in $topw.mid -side left -fill both -expand true
 pack $topw.scroll -in $topw.mid -side right -fill y
 
 #Load help.txt and put the contents in the text-widget
 $topw.text delete 1.0 end
 set f [open [join "$path $helpfile" /]]
 while {![eof $f]} {
   $topw.text insert end [read $f 1000]
 }
 close $f 
 
 # 3. Create exit-button at the bottom of the dialog-box
 
 button $topw.button -text Exit -command "set tk_priv(button) 1"
 pack $topw.button -in $topw.bot -expand 1 -padx 3m -pady 1m
 
 # 4. Withdraw the window, then update all the geometry information
 #    so we know how big it wants to be, then center the window
 #    in the display and de-iconify it.
 
 wm withdraw $topw
 update idletasks
 set x [expr [winfo screenwidth $topw]/2 - [winfo reqwidth $topw]/2 \
  - [winfo vrootx [winfo parent $topw]]]
 set y [expr [winfo screenheight $topw]/2 - [winfo reqheight $topw]/2 \
  - [winfo vrooty [winfo parent $topw]]]
 wm geom $topw +$x+$y
 wm deiconify $topw

 # 5. Set up marks and Bindings
 foreach el $helpchapterlines($language) {
   $topw.text tag add big [lindex $el 1].0 [lindex $el 1].end
}
 
 $topw.text tag configure big -font $fontbighelptext  
 $topw.text configure -state disabled
 $topw.text yview -pickplace $line.0
 
 # 6. Set a local grab and claim the focus too.

 set oldFocus [focus]
 grab $topw
 focus $topw.text

 # 7. Wait for the user to respond, then restore the focus and return
 #    the index of the selected button
 
 tkwait variable tk_priv(button)
 destroy $topw
 focus $oldFocus
 return $tk_priv(button)
}




