# the procedures in this file execute the various lpc functions

proc prcmds {{prcmd} {message {}}} {
# this procedure implements the following PLP functions:
# abort, clean, disable, down, enable, history, kill, start, stop, up
  global selectedprs w remote normalcol butcol
  set prnames [getprselection]
  if {$prnames == 0} {
    return 0
  } elseif {$remote==0} { 
       if [catch {eval exec lpc $prcmd $prnames $message } list1] {
       } else {
       } 
  } elseif {$remote==1} {
       if [catch {eval exec lpc rem $prcmd $prnames $message} list1] {
       } else {
       }
  }
  lpc-stat $selectedprs
  set element 0
  set element [lsearch -exact $list1 Rank ]
  if {$element > 0 } { 
    set list1 [ lrange $list1 0 [expr $element-1]] 
  }
  .buttonframe.selectall configure -relief raised
  .buttonframe.selectall configure -text SelectAll
  .buttonframe.selectall configure -bg $butcol -fg $normalcol
  $w.info.lpcinftextbox configure -state normal
  $w.info.lpcinftextbox delete 1.0 end
  $w.info.lpcinftextbox insert end $list1
  $w.info.lpcinftextbox configure -state disabled
}  

proc jobcmd {{cmd} {otherarg {}}} {
# Procedure to evaluate the functions: topq, downq, lprm
  set list {}
  global globalprname w remote butcol normalcol
  if {$cmd == "lprm"} {set prname -P$globalprname 
  } else {set prname $globalprname}
  set jobnrs [getjobselection]
  if {($remote == 1) && ($cmd != "lprm")} {
   foreach element $jobnrs {
      catch {exec lpc rem $cmd $prname $element $otherarg} list1
      lappend list $list1
   }
  } else { 
    foreach element $jobnrs {
      catch {exec lpc $cmd $prname $element $otherarg} list1 
      lappend list $list1
    }
  } 
  lpc-lpq $globalprname
  
  $w.info.lpcinftextbox configure -state normal
  $w.info.lpcinftextbox delete 1.0 end
  if {$jobnrs == 0} {
   $w.info.lpcinftextbox insert end "Please select Job(s) first!"
  } else {
   foreach element $list {
    $w.info.lpcinftextbox insert end "$element \n"
   }  
  }
  .buttonframe.selectall configure -relief raised
  .buttonframe.selectall configure -text SelectAll
  .buttonframe.selectall configure -bg $butcol -fg $normalcol
  $w.info.lpcinftextbox configure -state disabled
}

proc jobcmd1 {cmd} {
# Procedure to evaluate the functions; hold, one, release, requeue
  set list {}
  global globalprname w remote butcol normalcol
  set jobnrs 0
  set jobnrs [getjobselection]
  set anzahl [llength [getjobselection]]
#  puts "Wert von anzahl: $anzahl, jobnrs $jobnrs"
  if {($remote ==1) && ($cmd != "requeue")} { 
   foreach element $jobnrs {
     catch {exec lpc rem $cmd $globalprname $element } list1 
     lappend list $list1
   }
  } else {
      if {((($cmd == "one") || ($cmd == "requeue")) && ($anzahl != 1))} {
	  set text "Please select only ONE job!"
	  $w.info.lpcinftextbox configure -state normal
	  $w.info.lpcinftextbox delete 1.0 end
	  $w.info.lpcinftextbox configure -state disabled
	  set erg [dialog .error Error $text {} 0 Acknowledged]
	  if {$erg == 0} {
##	  $w.info.lpcinftextbox delete 1.0 end
##	  $w.info.lpcinftextbox insert end "Please select only one Job!"
	      selection clear
	      set anzahl 0
	      .buttonframe.selectall configure -relief raised
	      .buttonframe.selectall configure -text SelectAll
	      .buttonframe.selectall configure -bg $butcol -fg $normalcol
	      return
	  }
      } else {
	  foreach element $jobnrs {
	      catch {exec lpc $cmd $globalprname $element } list1
	      lappend list $list1
	  }
      }
  } 
  lpc-lpq $globalprname
  
  $w.info.lpcinftextbox configure -state normal
  $w.info.lpcinftextbox delete 1.0 end
  if {$jobnrs == 0} {
   $w.info.lpcinftextbox insert end "Please select Job(s) first!"
  } else {
   foreach element $list {
    $w.info.lpcinftextbox insert end "$element \n"
   }  
  }
  .buttonframe.selectall configure -relief raised
  .buttonframe.selectall configure -text SelectAll
  .buttonframe.selectall configure -bg $butcol -fg $normalcol
  $w.info.lpcinftextbox configure -state disabled
}

proc jobcmd2 {type} {
# Procedure to evaluate the functions: copy, move, chprio
 global destpr globalprname w
 set text "Select Destination Printer!"
 while 1 {
    if {([llength [$w.main.lpcstatlistbox curselection]]<1) && \
        ([llength [$w.main2.lpcstatlistbox curselection]]<1)} {
     $w.info.lpcinftextbox configure -state normal
     $w.info.lpcinftextbox delete 1.0 end
     $w.info.lpcinftextbox insert end "Please select Job(s) first!"
     $w.info.lpcinftextbox configure -state disabled
     return
    }
    set list [stat-listb]
    set printer $globalprname
    set printer [lindex $printer 0] 
    set index [lsearch -exact $list $printer]
    set list [lreplace $list $index $index] 
    set destpr {}
    set erg [dialistb .$type $type $text $list 0 Accept Cancel]
    if {$destpr=={} && $erg==0} {
      continue
     } else {
      break
     }
   }
   if {$erg==0} {
    jobcmd $type $destpr
   }
}

proc stat-listb {} {
# This procedure returns a list with the names of all printers.
# The list is necessary for the jobcmd2 procedure, where the destination printer
# is choosen from the list.

 if [catch {eval exec lpc -t lstat all } result] {
 } else {
 }
 # Break up list in output lines form lpc-stat 
 set list [split $result \n]
 set n [llength $list]
 # examine lines
 for {set i 1} {$i < $n} {incr i} {
   set temp [lindex $list $i]
   # test type of line 
   if {[string first " " $temp] !=0} {
    set length [string first " " $temp]
    # extract prname
    set prname [string range $temp 0 [expr $length-1]]
    set prnames [lappend prnames $prname]
   }
  }
  return $prnames
}

proc attach {} {
# executes lpc attach command
    global selectedprs destpr w remote
    set destpr {}
    set nrofelements [$w.main.lpcstatlistbox curselection]
    if {[llength $nrofelements] != 1} {
     $w.info.lpcinftextbox configure -state normal
     $w.info.lpcinftextbox delete 1.0 end
     $w.info.lpcinftextbox insert end "Please select single Printer !"
     return 0
     selection clear
    } else {
     set list [stat-listb]
     set text "Select Destination Printer: "
     set printer [$w.main.lpcstatlistbox get $nrofelements] 
     set printer [lindex $printer 0] 
     set index [lsearch -exact $list $printer]
     set list [lreplace $list $index $index] 
     set erg [dialistb .attach Attach $text $list 0 Accept Cancel]
     if {$destpr=={} && $erg==0} {
     return 1
     }
     switch $erg {
      0 { if {$remote==0} {
            if [catch {eval exec lpc attach $printer $destpr } list1] {
             return 0
            }
          } else {
            if [catch {eval exec lpc rem attach $printer $destpr} list1] {
             return 0
            }
          }          
          lpc-stat $selectedprs 
          $w.info.lpcinftextbox configure -state normal
          $w.info.lpcinftextbox delete 1.0 end
          $w.info.lpcinftextbox insert end $list1
          $w.info.lpcinftextbox configure -state disabled
          return 0
        }
      1 { return 0 }
     }
  }
}

proc unattach {} {
# executes lpc unattach command
  global selectedprs w remote
    set nrofelements [$w.main.lpcstatlistbox curselection]
    if {[llength $nrofelements] != 1} {
     $w.info.lpcinftextbox configure -state normal
     $w.info.lpcinftextbox delete 1.0 end
     $w.info.lpcinftextbox insert end "Please select single Printer !"
     selection clear
    } else {
     set printer [$w.main.lpcstatlistbox get $nrofelements] 
     set printer [lindex $printer 0]
     if {$remote==0} { 
       if [catch {exec lpc unattach $printer } list1] {
         return 0
       }
     } else {
       if [catch {exec lpc rem unattach $printer} list1] {
         return 0
       }
     }
     lpc-stat $selectedprs 
     $w.info.lpcinftextbox configure -state normal
     $w.info.lpcinftextbox delete 1.0 end
     $w.info.lpcinftextbox insert end $list1
     $w.info.lpcinftextbox configure -state disabled
     return 1
     }
}

proc killserver {} {
# terminates active printerserver
  global w lpd sunkenbg sunkenfg
  set lpd [exec lpc lpd]
  set lpdid [lindex $lpd 2]
  if {[regexp {^[0-9]+$} $lpdid]} {
     if {[catch {exec kill $lpdid} list1]==0} {
        $w.info.lpcinftextbox configure -state normal
        $w.info.lpcinftextbox delete 1.0 end
        $w.info.lpcinftextbox insert end $list1
        $w.info.lpcinftextbox configure -state disabled 
        set lpd "Server killed"
	.buttonframe.daemonpid configure -background red -foreground white
        
     } else {
	set lpd [exec lpc lpd]
        $w.info.lpcinftextbox configure -state normal
        $w.info.lpcinftextbox delete 1.0 end
        $w.info.lpcinftextbox insert end $list1
        $w.info.lpcinftextbox configure -state disabled  
	.buttonframe.daemonpid configure -background $sunkenbg -foreground green
     }
  } else {
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    $w.info.lpcinftextbox insert end "No Server present \n"
    $w.info.lpcinftextbox configure -state disabled
    .buttonframe.daemonpid configure -background red -foreground white
  }
} 

proc restartserver {} {
# restarts a printerserver
 global w lpd lpd_program sunkenbg
 set fehler [catch {exec $lpd_program} output]
 if {$fehler == 1} {
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    $w.info.lpcinftextbox insert end "Restart failed:\n"
    $w.info.lpcinftextbox insert end $output
    $w.info.lpcinftextbox configure -state disabled
    set lpd [exec lpc lpd]
    .buttonframe.daemonpid configure -bg red -fg white
  } else {
    after 1000
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    $w.info.lpcinftextbox configure -state disabled
    set lpd [exec lpc lpd]
    .buttonframe.daemonpid configure -bg cornsilk -fg forestgreen

  }
}
 
proc hupserver {} {
# terminates active printerserver
  global w lpd sunkenbg sunkenfg
  set lpd [exec lpc lpd]
  set lpdid [lindex $lpd 2]
  if {[regexp {^[0-9]+$} $lpdid]} {
     if {[catch {exec kill -HUP $lpdid} list1]==0} {
        $w.info.lpcinftextbox configure -state normal
        $w.info.lpcinftextbox delete 1.0 end
        $w.info.lpcinftextbox insert end $list1
        $w.info.lpcinftextbox configure -state disabled  
        set lpd "Server restarted"
	.buttonframe.daemonpid configure -bg cornsilk -fg blue
     } else {
	set lpd [exec lpc lpd]
        $w.info.lpcinftextbox configure -state normal
        $w.info.lpcinftextbox delete 1.0 end
        $w.info.lpcinftextbox insert end $list1
        $w.info.lpcinftextbox configure -state disabled  
	.buttonframe.daemonpid configure -bg cornsilk -fg forestgreen
     }
  } else {
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    $w.info.lpcinftextbox insert end "No Server present \n"
    $w.info.lpcinftextbox configure -state disabled
    .buttonframe.daemonpid configure -bg red -fg white

  }
} 
   
proc historyall {} {
global butcol normalcol
    selectallproc
    prcmds "history all all"
    .buttonframe.selectall configure -relief raised
    .buttonframe.selectall configure -text SelectAll
    .buttonframe.selectall configure -bg $butcol -fg $normalcol
    selection clear
}

