proc getprselection { } {
# gets the selection from the listbox in printermode
# and extracts a list with the selected printers
 global w
  if [catch {selection get} resultselection] {
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    set message2 "Please select Printer(s) first !"
    $w.info.lpcinftextbox insert end $message2
    $w.info.lpcinftextbox configure -state disabled       
    set prnames 0
  } else {   
    set list [split $resultselection \n]
    set n [llength $list]
    catch [set prnames {}]
    for {set i 0} {$i < $n} {incr i} {
      set temp [lindex $list $i]
      set temp2 [split $temp " "]
      set prname [lindex $temp2 0]
      lappend prnames $prname 
    }  
  }	
 return $prnames 
}

proc getjobselection { } {
# gets the selected lines from the listbox in jobmode
# and extracts a list with the selected jobnumbers
 global w
  if [catch {selection get} resultselection] {
    $w.info.lpcinftextbox configure -state normal
    $w.info.lpcinftextbox delete 1.0 end
    set message2 "Please select Job(s) first !"
    $w.info.lpcinftextbox insert end $message2
    $w.info.lpcinftextbox configure -state disabled       
    set jobnames 0
  } else {   
    set list [split $resultselection \n]
    set n [llength $list]
    catch [set jobnames {}]
    for {set i 0} {$i < $n} {incr i} {
      set temp [lindex $list $i] 
      split $temp " "
      set test [lindex $temp 3]
      if {[regexp {^[0-9]} $test]} {
        set jobname [lindex $temp 3]
      } else {
        set jobname [lindex $temp 1]
      } 
      lappend jobnames $jobname 
    }  
  }	
 return $jobnames 
}

proc dialog {topw title text widget default args} {
# modified version of dialog.tcl from the distribution
# it is able to integrate an entry-widget into the dialog.box
 global tk_priv 
 # 1. Create the top-level window and divide it into top 
 # and bottom part
 
 catch {destroy $topw}
 toplevel $topw -class Dialog
 wm title $topw $title
 wm iconname $topw Dialog
 wm protocol $topw WM_DELETE_WINDOW { }
 wm transient $topw [winfo toplevel [winfo parent $topw]]
 frame $topw.top -relief raised -bd 1
 pack $topw.top -side top -fill both -expand 1
 frame $topw.bot -relief raised -bd 1
 pack $topw.bot -side bottom -fill both
 
 # 2. Fill the top part with text and widget
 option add *Dialog.msg.wrapLength 3i widgetDefault
 label $topw.msg -width 25 -text $text 
 global fontdialog
 catch {$topw.msg configure -font $fontdialog }
 pack $topw.msg -in $topw.top -side top -expand 1 -fill both \
  -padx 3m -pady 3m
 switch $widget {
  entry { entry $topw.mesentry -width 31 -relief sunken -bd 2 \
           -textvariable message -exportselection 0
          pack $topw.mesentry -in $topw.top -side bottom -fill x \
           -padx 3m -pady 3m
         }
  shortentry { entry $topw.prioentry -width 1 -relief sunken -bd 2 \
           -textvariable prioentry -exportselection 0
          pack $topw.prioentry -in $topw.top -side bottom \
           -padx 3m -pady 3m
        }
 }
  
 # 3. Create buttons at the bottom of the dialog
 
 set i 0
 foreach but $args {
  button $topw.button$i -text $but -command "set tk_priv(button) $i"
  if {$i == $default} {
   frame $topw.default  -relief sunken -bd 1
   pack $topw.default -in $topw.bot -side left -expand 1 \
    -padx 3m -pady 2m
   pack $topw.button$i -in $topw.bot -side left -expand 1 \
    -ipadx 2m -ipady 1m
   bind $topw <Return> "$topw.button$i flash; set tk_priv(button) $i"
  } else {
   pack $topw.button$i -in $topw.bot -side left -expand 1 \
    -padx 3m -pady 3m -ipadx 2m -ipady 1m
  }
  incr i
 }
 
 # 4. Withdraw the window, then update all the geometry information
 #    so we know how big it wants to be, then center the window
 #    in the display and de-iconify it.
 
 wm withdraw $topw
 update idletasks
 set x [expr [winfo screenwidth $topw]/2 - [winfo reqwidth $topw]/2 \
  - [winfo vrootx [winfo parent $topw]]]
 set y [expr [winfo screenheight $topw]/2 - [winfo reqheight $topw]/2 \
  - [winfo vrooty [winfo parent $topw]]]
 wm geom $topw +$x+$y
 wm deiconify $topw
 
 # 5. Set a local grab and claim the focus too.

 set oldFocus [focus]
 grab $topw
 focus $topw

 # 6. Wait for the user to respond, then restore the focus and return
 #    the index of the selected button
 
 tkwait variable tk_priv(button)
 destroy $topw
 focus $oldFocus
 return $tk_priv(button)
}


proc dialistb { topw title text list default args} {
# modified version of dialog.tcl from the distribution
# this one implements a listbox in the dialogbox 
 global tk_priv activebg
 set destpr {} 
 # 1. Create the top-level window and divide it into top 
 # and bottom part
 
 catch {destroy .listb}
 toplevel $topw -class Dialog
 wm title $topw $title
 wm iconname $topw Dialog
 wm protocol $topw WM_DELETE_WINDOW { }
 wm transient $topw [winfo toplevel [winfo parent $topw]]
 frame $topw.top -relief raised -bd 1
 pack $topw.top -side top -fill both -expand 1
 frame $topw.bot -relief raised -bd 1
 pack $topw.bot -side bottom -fill both
 
 # 2. Fill the top part with text and widget
 option add *Dialog.msg.wrapLength 3i widgetDefault
 label $topw.msg -width 25 -text $text
 global fontdialog fontmain
 catch {$topw.msg configure -font $fontdialog }
 pack $topw.msg -in $topw.top -side top -expand 1 -fill both \
  -padx 3m -pady 3m
  
 listbox $topw.listbox -relief groove -borderwidth 2 \
	-yscrollcommand "$topw.scroll set" -font $fontmain\
        -selectmode single -exportselection 0 -selectbackground $activebg
 scrollbar $topw.scroll -command "$topw.listbox yview" -width 10
 pack $topw.listbox -side left -fill both -expand true
 pack $topw.scroll -side right -fill y
 
 #Put values of list in listbox
 $topw.listbox delete 0 end
 foreach index $list {
  $topw.listbox insert end $index
 }
 

 #Bindings for Listbox
 bind $topw.listbox <Button-1> {
  set index [%W nearest %y]
  set destpr [%W get $index]
 }  

 bind $topw.listbox <Double-1> {
  set index [%W nearest %y]
  set destpr [%W get $index] 
 } 
 bind $topw.listbox <Double-1> "set tk_priv(button) $default"
 
 
 
 # 3. Create buttons at the bottom of the dialog
 
 set i 0
 foreach but $args {
  button $topw.button$i -text $but -command "set tk_priv(button) $i"
  if {$i == $default} {
   frame $topw.default  -relief sunken -bd 1
   pack $topw.default -in $topw.bot -side left -expand 1 \
    -padx 3m -pady 2m
   pack $topw.button$i -in $topw.bot -side left -expand 1 \
    -ipadx 2m -ipady 1m
   bind $topw <Return> "$topw.button$i flash; set tk_priv(button) $i"
  } else {
   pack $topw.button$i -in $topw.bot -side left -expand 1 \
    -padx 3m -pady 3m -ipadx 2m -ipady 1m
  }
  incr i
 }
 
 # 4. Withdraw the window, then update all the geometry information
 #    so we know how big it wants to be, then center the window
 #    in the display and de-iconify it.
 
 wm withdraw $topw
 update idletasks
 set x [expr [winfo screenwidth $topw]/2 - [winfo reqwidth $topw]/2 \
  - [winfo vrootx [winfo parent $topw]]]
 set y [expr [winfo screenheight $topw]/2 - [winfo reqheight $topw]/2 \
  - [winfo vrooty [winfo parent $topw]]]
 wm geom $topw +$x+$y
 wm deiconify $topw
 
 # 5. Set a local grab and claim the focus too.

 set oldFocus [focus]
 grab $topw
 focus $topw

 # 6. Wait for the user to respond, then restore the focus and return
 #    the index of the selected button
 
 tkwait variable tk_priv(button)
 destroy $topw
 focus $oldFocus
 return $tk_priv(button)
}



