#ifndef LIBRARY_UTILS_H
#define LIBRARY_UTILS_H

#ifndef _FCNTL_H
#include <fcntl.h>
#endif

#ifdef __SVR4
extern int gethostname (char *, int);
#endif

FILE *fopen_daemon (char *, char *);
FILE *fopen_path (char *, char *);
char **copy_haddr_list (char **);
char *Decode_status (plp_status_t *);
char *Time_str (void);
char *Time_str_hist (time_t);
char *Time_str_cde (time_t);
char *current_options (void);
char *estrcp (char *, char *, char *);
char *host_in_domain (char *, char *);
char *possible_options (void);
char *reallocstrcpy (char *, char *, int);
const char *get_fqdn (const char *);
inline DIR *opendir_SD (void);
inline void chdir_SD (void);
int Job_match (char *, char *);
int Match_entry (struct plp_queue *);
int bpread (int, char *, int);
int chmod_daemon (char *, int);
int copy_file (char *, char *, int);
int create_history_entry (int , struct plp_queue *);
int hostcmp (char *, char *);
int mkdir_daemon (char *, int);
int open_daemon (char *, int, int);
int unlink_daemon (char *);
int update_history (void);
int valid_forms (char *, char *);
long current_limit (void);
pid_t Checkactive (void);
void Get_Daemon (void);
void Get_Local_fqdn (void);
void Log_cf (char *, char *, int);
void Print_comment (const char *);
void Print_queuehead (long, const char *);
void Remove_job (FILE *, struct plp_queue *);
void Rename_cf (char *);
void Shift_parms (int);
void Std_environ (int, char **, char **);
void allocParmsIfNeeded (void);
void empty_cfparms (void);
void fix_SD (void);
void free_haddr_list (char **);
void growParmsIfNeeded (void);
void lower_case (char *);
void printstatus (int);
void setup_clean_fds (void);
void splitline (char *);

#endif
