/***************************************************************************
 * U. Minnesota LPD Software * Copyright 1987, 1988, Patrick Powell
 ***************************************************************************
 * MODULE: statustool.c
 * Tool to set the status for a given printer -- really simple
 ***************************************************************************/


#include "lp.h"
#include "patchlevel.h"
#include "common/setstatus.h"
#include "library/errormsg.h"
#include "library/readconf.h"

int
main (int argc, char *argv[], char *envp[]) {
    if (argc < 2) {
	fprintf (stderr, "Usage: setstatus printer \"message\"\n");
	exit (1);
    }
    Std_environ (argc, argv, envp);
    Readconf ();

    if (UserUID != 0 && UserUID != DaemonUID) {
	fprintf (stderr, "setstatus: only as root or daemon!\n");
	return 1;
    }
    Printer = argv[1];
    Get_Printer (1);
    chdir_SD ();
    setstatus (argv[2]);
    return 0;
}

plp_signal_t cleanup(int signal) {;}
